
void internal_adc_config()
{
// Configure ADC
    EALLOW;
    Adc1Regs.ADCCTL2.bit.ADCNONOVERLAP 	= 1;     // Enable non-overlap mode i.e.
                                                // conversion and future

	Adc1Regs.ADCSOC0CTL.bit.CHSEL      	= 2;     // set SOC0 channel select to
                                                // ADC1A0
    Adc1Regs.ADCSOC1CTL.bit.CHSEL      	= 7;     // set SOC1 channel select to
                                                // ADC1A7
    Adc1Regs.ADCSOC2CTL.bit.CHSEL      	= 4;     // set SOC1 channel select to
    Adc1Regs.INTSEL1N2.bit.INT1SEL      = 2;     // setup EOC0 to trigger ADCINT1
    AnalogSysctrlRegs.TRIG1SEL.all     = 0;     // Assigning EPWM1SOCA to
                                                // ADC TRIGGER 1 of the ADC module                                              // to fire
    Adc1Regs.INTSEL1N2.bit.INT1CONT    = 0;     // Disable ADCINT1 Continuous
                                                 // mode
     Adc1Regs.INTSEL1N2.bit.INT1E       = 1;     // Enabled ADCINT1

    Adc1Regs.ADCCTL1.bit.INTPULSEPOS = 1;    //ADCINTs trigger at end of
                                             // conversion
    Adc1Regs.ADCSOC0CTL.bit.ACQPS  		= 6;

    Adc1Regs.ADCSOC1CTL.bit.ACQPS  		= 6;
    Adc1Regs.ADCSOC2CTL.bit.ACQPS  		= 6;
    EDIS;

}

#include "DSP28x_Project.h"     // Device Headerfile and Examples Include File
#define C28_FREQ    150         //CPU frequency in MHz

long int c28_r_array[2048];     // mapped to S2 of shared RAM owned by M3
long int c28_r_w_array[2048];   // mapped to S0 of shared RAM owned by c28
long int c28_r_w_array_2[2048];   // mapped to S1 of shared RAM owned by c28

#pragma DATA_SECTION(c28_r_array,"SHARERAMS3");
#pragma DATA_SECTION(c28_r_w_array,"SHARERAMS0");
#pragma DATA_SECTION(c28_r_w_array_2,"SHARERAMS1");

__interrupt void cpu_timer0_isr(void);// mapped to S1 of shared RAM owned by c28
__interrupt void cpu_timer1_isr(void);// mapped to S1 of shared RAM owned by c28
__interrupt void cpu_timer2_isr(void);// mapped to S1 of shared RAM owned by c28

void Shared_Ram_dataRead_c28(void); // function to read data from shared RAM owned by M3
void Shared_Ram_dataWrite_c28(void);// function to write data from shared RAM owned by c28
void internal_adc_config();
long int ad_buffer[3];

void main(void)
{

   InitSysCtrl();

   InitGpio();  // Skipped for this example
   EALLOW;
   GpioCtrlRegs.GPCDIR.bit.GPIO70 = 1;
   EDIS;
   DINT;
   InitPieCtrl();
   IER = 0x0000;
   IFR = 0x0000;
   InitPieVectTable();
   EALLOW;  // This is needed to write to EALLOW protected registers
   PieVectTable.TINT0 = &cpu_timer0_isr;
   PieVectTable.TINT1 = &cpu_timer1_isr;
   PieVectTable.TINT2 = &cpu_timer2_isr;
   EDIS;    // This is needed to disable write to EALLOW protected registers
   InitCpuTimers();   // For this example, only initialize the Cpu Timers
   ConfigCpuTimer(&CpuTimer0, C28_FREQ, 1000000);
   ConfigCpuTimer(&CpuTimer1, C28_FREQ, 1000000);
   ConfigCpuTimer(&CpuTimer2, C28_FREQ, 1000000);

   CpuTimer0Regs.TCR.all = 0x4001; // Use write-only instruction to set TSS bit = 0
   CpuTimer1Regs.TCR.all = 0x4001; // Use write-only instruction to set TSS bit = 0
   CpuTimer2Regs.TCR.all = 0x4001; // Use write-only instruction to set TSS bit = 0


   InitAdc1();

   IER |= M_INT1;
   IER |= M_INT13;
   IER |= M_INT14;

// Enable TINT0 in the PIE: Group 1 interrupt 7
   PieCtrlRegs.PIEIER1.bit.INTx7 = 1;

   EINT;   // Enable Global interrupt INTM
   ERTM;   // Enable Global realtime interrupt DBGM

   Shared_Ram_dataWrite_c28();
   Shared_Ram_dataRead_c28();
   internal_adc_config();
  while(1)
   {
	  ad_buffer[2]++;
	  Adc1Regs.ADCSOCFRC1.all = 0x0007;
	  while (Adc1Regs.ADCINTFLG.bit.ADCINT1 == 0) ;
	  Adc1Regs.ADCINTFLGCLR.bit.ADCINT1= 1;
	  ad_buffer[0]=Adc1Result.ADCRESULT0;
	  ad_buffer[1]=Adc1Result.ADCRESULT1;
	  ad_buffer[2]=Adc1Result.ADCRESULT2;


   }
}



